Strict

Rem
Name: Space Race
Von: Christian Geiler, alias Firstdeathmaker
Datum: 5.4.2006
End Rem
Const Version:String = "1.55"
Global DEBUG:Byte = False
Global RISKFACTOR:Float = 2.0
AppTitle = ("Space Race "+Version)
Rem

1.55
 + Es werden alle Asteroiden als Risikofaktoren gezhlt die nah genug sind , nicht nur der nchste.
 + Globaler Risikofaktor , bestimmt wie stark riskante Aktionen gewertet werden sollen.
 + Neue Highscoreeintrge werden hervorgehoben
 + Highscoreeintrge durchnummeriert
 + Mit KEY_D Debugmodus ein/ausschalten


1.5
 + Highscoreeintrge variable Menge
 + Namensfeld fr Highscoreeintrge
 + Leerzeichen vor und hinter Namen werden entfernt
 + Automatisches Einstellen der Auflsung bei nichtvorfinden der Option.Ini

1.41
 + Graphicsscale Bug entfernt
 + berprfung ob der Computer die Auflsung darstellen kann , ansonsten Warnmeldung.


1.4
 + BUG ltere Option.Ini werden nun automatisch ergnzt.

1.3
 + Highscore
 + Grn bei Asteroidensurfbonus
 + Risikobonus bei Wandberhrung (nach x-Speed)
 + Risikobonus bei Deckenberhrung (nach GAME_SHIPSPEED)
 + Risikobonus bei Glut, 1 Pkt fr 1% Glutschaden (proportional)
 + Kleine Explosion bei Feuerballberhrung

1.2
 +Triebwerke anderer Partikeleffekt
 +Sonnenblle
 +Erhitzen des Raumschiffes (Bei 100% -> Tod) durch Feuerblle und Sonne
 +Neustarten des Spieles
 +Neue Raumschiffgrafik + Grafikbreitenabhngige Wandkollision
 +Meteoriten verglhen in Explosion
 +Spielertod durch bessere Explosion

1.1
 +Risikopunkte
 +Meteoritenanzahl Auflsungsabhngig
 +Punktefunktion eingebaut

1.0
 +Asteroiden
 +Partikelsystem
 +Punktesystem

End Rem
Include "MD5.bmx"

SeedRnd MilliSecs()

Global GFX_X:Int
Global GFX_Y:Int
Global GFX_FULL:Byte
Global GFX_SCALE:Float
Global GAME_PLAYERID:String

Global Stream:TStream = ReadFile ("Options.ini")
If Stream <> Null
	GFX_X = Int(ReturnLine:String(Stream,"GFX X"))
	GFX_Y = Int(ReturnLine:String(Stream,"GFX Y"))
	GFX_Full = Byte((ReturnLine:String(Stream,"GFX Full")>0) * 32)
	GAME_PLAYERID = ReturnLine:String(Stream,"Player"+GAME_PLAYERID)
Else
	GFX_X = 800'DesktopWidth()
	GFX_Y = 600'DesktopHeight()
	GFX_FULL = 32'DesktopDepth()
	Options_Save()
EndIf

GFX_SCALE = ( ( (GFX_X) / (1280.0) + ( GFX_Y / 800.0 ) ) / 2.0 )
If GAME_PLAYERID = "" GAME_PLAYERID = "Pilot"
If Stream<>Null CloseFile Stream
Options_Save()


Global Time_mod:Float
Global Time_LastUpdate:Int
Global Time_Now:Int
Global Time_MS:Int
Global Time_FPS:Float
Global Time_FrameBreak:TTimer = CreateTimer(75,Null)

Global GAME_FLIGHTSPEED:Float
Global GAME_SHIPSPEED:Float
Global GAME_OVER:Byte
Global GAME_AsteroidsNumber:Int
Global GAME_Time_Asteroids:Int
Global GAME_FireballNumber:Int

Global GAME_TIME:Int
Global GAME_ASTEROIDS:Int
Global GAME_RISIKO:Float

Global GAME_EXIT:Byte

Global GFX:TGraphics = Graphics (GFX_X , GFX_Y , GFX_FULL)
If Not GFX
	Notify ("graphicsmode not possible: " + GFX_X + " x " + GFX_Y + ", please change graphicsmode in Options.ini file")
	End
EndIf

Function Points:Int()
	Return Int(Ceil(GAME_TIME/1000.0 * GAME_FLIGHTSPEED + GAME_RISIKO))
End Function

Function GAME_Progress()
	GAME_FLIGHTSPEED = 10 + (GAME_TIME/5000.0)
	GAME_SHIPSPEED = GAME_FLIGHTSPEED
	GAME_AsteroidsNumber = Int(Ceil(GAME_FLIGHTSPEED)/(GFX_X/1280.0))
	GAME_Time_Asteroids = 20000 / GAME_AsteroidsNumber
	GAME_FireballNumber = 1 + Sqr(Points() / 500)
End Function

Function GAME_Init()
	GAME_TIME = 0
	GAME_RISIKO = 0
	GAME_OVER = 0
	GAME_Progress()
	ClearList TAsteroid.TAsteroid_List
	ClearList TParticle.TParticle_List
	ClearList TFireball.TFireball_List
	Player.Init()
End Function

Function Options_Save()
	Stream = WriteFile ("Options.ini")
	WriteLine (Stream,"GFX X="+GFX_X)
	WriteLine (Stream,"GFX Y="+GFX_Y)
	WriteLine (Stream,"GFX Full="+(GFX_Full>0))
	WriteLine (Stream,"Player="+GAME_PLAYERID)
	CloseFile Stream
End Function

Function TIME_Update()
	Time_Now = MilliSecs()
	Time_MS = Time_Now - Time_LastUpdate
	Time_mod = Time_MS / 1000.0
	Time_FPS = 1000.0 / Time_MS
	Time_LastUpdate = Time_Now
	WaitTimer (Time_FrameBreak)
End Function


Type TRocket
	Field Image:TImage
	Field Xw:Int,Yw:Int'Breite/Hhe d. Rakete
	Field X:Float
	Field Y:Float
	
	Field Rotation:Float
	Field Speed:Float
	Field Acceleration:Float
	
	Field EnginePartikel:Float
	Field EngineLeft:Byte
	Field EngineRight:Byte
	Field EngineOff:Byte
	
	Field Glut:Float
	
	Field Risiko:Byte
	
	Field NearestAsteroid:TAsteroid
	
	Field DEAD:Int
	
	Method New()
		Self.Image = LoadImage("Rocket.PNG")
		Self.Xw = ImageWidth(Self.Image)
		Self.Yw = ImageHeight(Self.Image)
		MidHandleImage Self.Image
	End Method
	
	Method Init()
		Self.DEAD = 0
		Self.X = GFX_X/2
		Self.Y = GFX_Y/2
		Self.Speed = GAME_SHIPSPEED
		Self.Acceleration = 10
		Self.Rotation = 0
		Self.EngineLeft = 0
		Self.EngineRight = 0
		Self.EngineOff = 0
		Self.NearestAsteroid = Null
		Self.Glut = 0
	End Method
	
	Method Draw()
		If Self.Dead = 0
			Local r:Byte,g:Byte,b:Byte'Fr das Spielerschiff
			
			r = 255
			g = 255
			b = 255
			
			If self.Glut>1 self.Glut = 1
			g = 255*(1-Self.Glut)
			b = 255*(1-self.Glut)
			
			If Risiko
				r = 0
				b = 0
			EndIf
			
			SetScale GFX_SCALE , GFX_SCALE
			SetRotation Self.Rotation
			SetAlpha 0.5
			SetColor 0,0,0
			DrawImage Self.Image,Self.X+5,Self.Y+5
			SetAlpha 1
			SetColor r,g,b
			DrawImage Self.Image,Self.X,Self.Y
			SetRotation 0
			
			If Player.Glut>0
				SetColor 0,0,0
				SetAlpha 0.5
					DrawText Int((Player.Glut)*100)+"%",Self.X-8,Self.Y+2
				SetColor 255,255,0
				SetAlpha 1
					DrawText Int((Player.Glut)*100)+"%",Self.X-10,Self.Y
				SetColor 255,255,255
			EndIf
		
			Local d:Float = 180-Self.Rotation + Rnd(-5,5)
			Local s:Float =  500

		
			Local ey:Float = -40 * GFX_SCALE 'EnginePosition
		
			Local sx:Float = Self.X + Sin(Rotation) * ey
			Local sy:Float = Self.Y - Cos(Rotation) * ey
			Local sxv:Float = Cos(Rotation) * 10.0 * GFX_SCALE
			Local syv:Float = Sin(Rotation) * 10.0 * GFX_SCALE
		
			Self.EnginePartikel:+ TIME_MS/15.2
			Local Pnumber:Int = Floor(Self.EnginePartikel)
			Self.EnginePartikel:-Pnumber
		
			If Pnumber>0
				SetBlend (LIGHTBLEND)
				For Local i=1 To Pnumber
					Local P:TParticle
					If EngineOff=0
						P:TParticle = TParticle.Create:TParticle(Fire,sx,sy,-d,s,Rnd(0,360),0,Rand(200,200))
						P.Calculate(i)
					EndIf
					If EngineRight
						P:TParticle = TParticle.Create:TParticle(Fire2,sx-sxv,sy-syv,+25-d,s,Rnd(0,360),0,Rand(200,200))
						P.Calculate(i)
					EndIf
					If EngineLeft
						P:TParticle = TParticle.Create:TParticle(Fire2,sx+sxv,sy+syv,-25-d,s,Rnd(0,360),0,Rand(200,200))
						P.Calculate(i)
					EndIf
				Next
				SetBlend (ALPHABLEND)
			EndIf
		EndIf
	End Method
	
	Method Steering()
		Self.Risiko = 0
		If Self.DEAD
			Self.DEAD:+ TIME_MS
		Else
			Self.EngineLeft = 0
			Self.EngineRight = 0
			Self.EngineOff = 0
		
			If KeyDown(KEY_LEFT)
				Self.Rotation:- 50.0 * Time_mod
				Self.EngineLeft = 1
			EndIf
		
			If KeyDown(KEY_Right)
				Self.Rotation:+ 50.0 * Time_mod
				Self.EngineRIght = 1
			EndIf
		
			If KeyDown(KEY_UP) Self.Speed:+Self.Acceleration * Time_mod
			If KeyDown(KEY_DOWN)
				Self.Speed:-Self.Acceleration * Time_mod
				Self.EngineOff = 1
			EndIf
				
			Self.X:+ Sin(Self.Rotation)*Self.Speed
			Self.Y:- Cos(Self.Rotation)*Self.Speed - GAME_SHIPSPEED
		
			'Kollisionen mit dem Rand
			If Self.X > GFX_X-Self.Xw Or Self.X < Self.Xw
				Self.Rotation = 360-Self.Rotation
				TParticle.Create:TParticle(Funken,Self.X,Self.Y,0,0,Rnd(0,360),0,Rand(500,1500))
				GAME_Risiko:+1*Abs(Sin(self.Rotation)*self.Speed) * RISKFACTOR
			EndIf
			
			'Kollision mit Decke
			If Self.Y < 0
				Self.Speed = 2*GAME_FLIGHTSPEED - Self.Speed
				TParticle.Create:TParticle(Funken,Self.X,Self.Y,0,0,Rnd(0,360),0,Rand(500,1500))
				GAME_Risiko:+1*Abs((self.Speed-GAME_SHIPSPEED)) * RISKFACTOR
			ElseIf Self.Y > GFX_Y
				Player.Crash()
			ElseIf Self.Y > GFX_Y - 100
				Player.Glut:+1.0 * TIME_mod
				GAME_Risiko:+50* TIME_mod * RISKFACTOR
			EndIf
				
				
			If Player.Glut>= 1
				Player.Crash()
			EndIf
			If Player.Glut>0
				Player.Glut:- 0.1 * TIME_mod
				If Player.Glut<0 Player.Glut = 0
			EndIf
			
			Local _close_asteroids:TList = TAsteroid.GetAsteroids(Self.X,Self.Y,100)
			
			For Local a:TAsteroid = EachIn _close_asteroids
				Local distance:Float = (Sqr((Self.X-a.X)^2+(Self.Y-a.Y)^2) - (a.Size * 50)) / GFX_SCALE
				GAME_RISIKO:+ (100-distance) * Time_mod * GAME_FLIGHTSPEED * Self.NearestAsteroid.Size / 100.0 * RISKFACTOR
				Self.Risiko = 1
				If DEBUG DrawLine Self.X,Self.Y,a.x,a.y
			Next
			
		EndIf	
	End Method
	
	Method Crash()
		Self.Dead = 1
		For Local i=0 To 20
			TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(0,360),Rand(0,200),Rnd(0,360),0,Rand(500,2000))
			TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(0,360),200,Rnd(0,360),0,Rand(500,2000))
			TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(0,360),500,Rnd(0,360),0,Rand(500,2000))
			TParticle.Create:TParticle(RocketExplode,Self.X,Self.Y,Rand(0,360),Rand(150,800),Rnd(0,360),0,Rand(250,500))
		Next
		For Local i=0 To 359
			TParticle.Create:TParticle(Fire,Self.X,Self.Y,i,150,Rnd(0,360),0,Rand(500,2000))
		Next
	End Method
End Type

Type TBackground
	Field Image:TImage
	Field X:Float
	Field Y:Float
	Field Xspeed:Float
	Field Yspeed:Float
	
	Method Init(Imagepath:String,Xspeed:Float=0,Yspeed:Float=0)
		Self.Image = LoadImage(Imagepath)
		Self.Xspeed = Xspeed
		Self.Yspeed = Yspeed
	End Method
	
	Method SetSpeed(Xspeed:Float,Yspeed:Float)
		Self.Xspeed = Xspeed
		Self.Yspeed = Yspeed
	End Method
	
	Method Draw()
		SetBlend(ALPHABLEND)
		SetScale 1,1
		SetColor 255,255,255
		SetRotation 0
		
		Self.X:+ Self.Xspeed * Time_mod
		Self.Y:+ Self.Yspeed * Time_mod
		TileImage Self.Image,Self.X,Self.Y
	End Method
End Type

Type TStar
	Global StarList:TList
	Global StarImages:TImage[3]
	Global StarSpeed:Float
	Global StarNumber:Int

	Field Art:Byte
	Field R:Byte,G:Byte,B:Byte
	Field Size:Float
	Field X:Float,Y:Float
	Field Speed:Float
	Field Rotation:Float
	Field _link:TLink
	
	Function Init()
		StarSpeed = 5
		StarNumber = 30
		
		For Local i=1 To StarNumber
			Local S:TStar = TStar.Create()
			S.Y = Rand(0,GFX_Y)
		Next
	End Function
		
	
	Function Update()
		If CountList(StarList)<StarNumber
			TStar.Create()
		EndIf
		TStar.Draw
	End Function
	
	Function Create:TStar()
			If StarList:TList = Null
				StarList:TList = New TList
				AutoMidHandle 1
				StarImages[0] = LoadImage("Star1.png")
				StarImages[1] = LoadImage("Star2.png")
				StarImages[2] = LoadImage("Star3.png")
				AutoMidHandle 0
			EndIf
	
			Local S:TStar = New TStar
			S.Art = Rand(0,2)
			S.R = Rand(150,255)
			S.G = Rand(150,255)
			S.B = Rand(150,255)
			S.Size = Rnd(0.5,1.5)
			S.X = Rand (0,GFX_X)
			S.Speed = Rnd(20,50)
			S.Rotation = Rnd(0,360)
			S._link = StarList.Addlast(S)
			Return S
	End Function
	
	Function Draw()
		SetBlend (LIGHTBLEND)
		For Local S:TStar = EachIn StarList
			S.Y:+S.Speed * TIME_mod * StarSpeed
			If S.Y > GFX_Y+50 S.Kill()
			SetColor S.R,S.G,S.B
			SetRotation S.Rotation
			SetScale S.Size,S.Size
			
			DrawImage StarImages[S.Art],S.X,S.Y
		Next
		
		SetBlend(ALPHABLEND)
		SetScale 1,1
		SetColor 255,255,255
		SetRotation 0
	End Function
	
	Method Kill()
		RemoveLink(Self._link)
	End Method
End Type

Type TParticle
	Global TParticle_List:TList

	Field Info:TParticle_Info
	Field X:Float
	Field Y:Float
	Field Direction:Float
	Field Speed:Float
	Field Rotation:Float
	Field RotationSpeed:Float
	Field MaxLiveTime:Int
	Field NowLiveTime:Int
	Field _link:TLink
	
	Function Create:TParticle(Info:TParticle_Info,X:Float,Y:Float,Direction:Float,Speed:Float,Rotation:Float,RotationSpeed:Float,MaxLiveTime:Int)
		Local TP:TParticle = New TParticle
			TP.Info = Info
			TP.X = X
			TP.Y = Y
			TP.Direction = Direction
			TP.Speed = Speed * GFX_SCALE
			TP.Rotation = Rotation
			TP.RotationSpeed = RotationSpeed
			TP.MaxLiveTime = MaxLiveTime
			TP._link = TParticle_List.Addlast(TP)
		Return TP
	End Function
	
	Function Update()
		SetBlend(LIGHTBLEND)
		SetScale GFX_SCALE,GFX_SCALE
		For Local P:TParticle = EachIn TParticle_List
			P.Calculate(TIME_MS)
		Next
		SetColor 255,255,255
		SetRotation 0
		SetScale 1,1
		SetAlpha 1
	End Function
	
	Method Calculate(MSMod:Float)
		Local TMod:Float = MSMod/1000.0
		Self.X:+ Sin(Self.Direction) * TMod * Self.Speed
		Self.Y:- Cos(Self.Direction) * TMod * Self.Speed
		Self.Rotation:+ Self.RotationSpeed * TMod
		Self.NowLiveTime:+MSMod
		If Self.NowLiveTime>Self.MaxLiveTime RemoveLink(Self._link)
		Self.Draw()
	End Method
		
	Method Draw()
		Local E:Float = Self.NowLiveTime / Float(Self.MaxLiveTime)
		Local S:Float = 1.0 - E
		SetColor (S*Info.SR+E*Info.ER),(S*Info.SG+E*Info.EG),(S*Info.SB+E*Info.EB)
		SetAlpha (S*Info.SA+E*Info.EA)
		DrawImage Self.Info.Image,Self.X,Self.Y
	End Method
End Type
	
Type TParticle_Info
	Field Image:TImage
	Field SR:Byte,SG:Byte,SB:Byte,SA:Float
	Field ER:Byte,EG:Byte,EB:Byte,EA:Float
	
	Function Create:TParticle_Info(Pfad:String,SR:Byte,SG:Byte,SB:Byte,SA:Float,ER:Byte,EG:Byte,EB:Byte,EA:Float)
		Local TPI:TParticle_Info = New TParticle_Info
			TPI.Image = LoadImage(Pfad)
			MidHandleImage(TPI.Image)
			TPI.SR = SR
			TPI.SG = SG
			TPI.SB = SB
			TPI.SA = SA
			TPI.ER = ER
			TPI.EG = EG
			TPI.EB = EB
			TPI.EA = EA
		Return TPI
	End Function
End Type

Type TAsteroid
	Global TAsteroidImages:TImage[10]
	Global TAsteroid_List:TList
	Global NextAsteroid:Int'Time when Next can be createt
	
	Field X:Float
	Field Y:Float
	Field Direction:Float
	Field Speed:Float
	Field Art:Byte
	Field Size:Float
	Field R:Byte,G:Byte,B:Byte
	Field Rotation:Float
	Field RotationSpeed:Float
	Field NaehePlayer:Float
	Field _link:TLink
	
	Function Init()
		AutoMidHandle 1
		For Local i=1 To 10
			TAsteroidImages[i-1] = LoadImage("Asteroid"+i+".png")
		Next
		AutoMidHandle 0
		TAsteroid_List = New TList
	End Function
	
	Function Update()
		SetBlend ALPHABLEND
		If CountList(TAsteroid_List)<GAME_AsteroidsNumber And TIME_Now>NextAsteroid
			TAsteroid.Create()
			NextAsteroid = TIME_Now + GAME_Time_Asteroids
		EndIf
		
		For Local A:TAsteroid = EachIn TAsteroid_List
			A.Process()
		Next
		SetScale 1,1
		SetRotation 0
		SetColor 255,255,255
		SetBlend ALPHABLEND
	End Function
	
	Function Create:TAsteroid()
		Local A:TAsteroid = New TAsteroid
			A.X = Rand(0,GFX_X)
			A.Direction = 180 + Rnd(-20,20)
			A.Speed = GAME_FLIGHTSPEED * Rnd(5.9,7.1) * GFX_SCALE
			A.Art = Rand(0,9)
			A.Size = Rnd(0.5,2)
			A.R = Rand(200,255)
			A.G = Rand(200,255)
			A.B = Rand(200,255)
			A.Y = -50 * A.Size
			A.Rotation = Rand(0,360)
			A.Rotationspeed = Rnd(-5,5) * GAME_FLIGHTSPEED
			A._link = TAsteroid_List.Addlast(A)
		Return A
	End Function
	
	Function GetAsteroids:TList(x:Float , y:Float , r:Float)
		Local return_list:TList = New TList
		For Local a:TAsteroid = EachIn TAsteroid_List
			If ( (Sqr( (x - a.X) * (x - a.X) + (y - a.y) * (y - a.y) ) - (a.Size * 50) ) / GFX_SCALE) < r Then return_list.Addlast(a)
		Next
		Return return_list
	End Function
	
	Method Process()
		Self.X:+ Sin(Self.Direction) * Self.Speed * TIME_mod
		Self.Y:- Cos(Self.Direction) * Self.Speed * TIME_mod
		Self.Rotation:+ Rotationspeed * TIME_mod
		
		'Check Nhe zum Asteroiden
		Self.NaehePlayer = Sqr((Self.X-Player.X)^2+(Self.Y-Player.Y)^2) - (Self.Size*50)
		
		If Player.NearestAsteroid<>Null
			If Player.NearestAsteroid.NaehePlayer>Self.NaehePlayer Player.NearestAsteroid = Self
		Else
			Player.NearestAsteroid = Self
		EndIf
		
		If Self.X<-50*Self.Size Or Self.X>GFX_X+50*Self.Size
			Self.Kill()
		ElseIf	Self.Y>GFX_Y+50*Self.Size-50
			For Local i2=0 To Ceil(Self.Size)
			For Local i=0 To 10
				TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(-90,90),Rand(0,200),Rnd(0,360),0,Rand(500,2000))
				TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(-90,90),Rand(150,300),Rnd(0,360),0,Rand(500,2000))
			Next
			Next
			Self.Kill()
		EndIf
		Self.Draw()
	End Method
	
	Method Kill()
		RemoveLink(Self._link)
		If Player.DEAD = 0 GAME_ASTEROIDS:+1
	End Method
	
	Method Draw()
		SetScale Self.Size * GFX_SCALE,Self.Size * GFX_SCALE
		SetRotation Self.Rotation
		SetColor 0,0,0
		SetAlpha 0.5
		DrawImage TAsteroid.TAsteroidImages[Self.Art],Self.X+5,Self.Y+5
		
		SetColor Self.R,Self.G,Self.B
		SetAlpha 1
		DrawImage TAsteroid.TAsteroidImages[Self.Art],Self.X,Self.Y
		
		'Kollision mit Spieler
		If Player.DEAD = 0
			If ImagesCollide2(TAsteroid.TAsteroidImages[Self.Art],Self.X,Self.Y,0,Self.Rotation,(Self.Size * GFX_SCALE),(Self.Size * GFX_SCALE),Player.Image,Player.X,Player.Y,0,Player.Rotation,GFX_SCALE,GFX_SCALE)
				Player.Crash()
			EndIf
		EndIf
	End Method
End Type

Type TFireball
	Global FireballImage:TImage
	Global TFireBall_List:TList
	Global NextCreation:Int
	
	Field X:Float
	Field Y:Float
	Field Speed:Float
	Field Direction:Float
	Field _link:TLink
	
	Function Init()
		If TFireBall_List=Null TFireBall_List:TList = New TList
		FireballImage = LoadImage("Fireball.png")
		MidHandleImage FireballImage
	End Function
	
	Function Create:TFireball()
		Local F:TFireball = New TFireball
		F.X = Rand(0,GFX_X)
		F.Y = GFX_Y
		F.Direction = Rnd(-25,25)
		F.Speed = Rnd(350,380) * GFX_SCALE
		F._link = TFireBall_List.Addlast(F)
		NextCreation = MilliSecs() + 10000 / GAME_FireballNumber
	End Function
	
	Function Update()
		SetBlend LIGHTBLEND
		SetScale GFX_SCALE,GFX_SCALE
		If CountList (TFireball_list)<GAME_FireballNumber And NextCreation<MilliSecs()
			TFireball.Create()
		EndIf
		For Local F:TFireball = EachIn TFireball_list
			F.Process()
		Next
		SetBlend ALPHABLEND
		SetScale 1,1
	End Function
	
	Method Process()
		Local xs:Float = Sin(Self.Direction) * Self.Speed
		Local ys:Float = -Cos(Self.Direction) * Self.Speed + 100 * TIME_mod * GFX_SCALE
		Self.Direction = ATan2(xs,-ys)
		Self.Speed = Sqr(xs^2+ys^2)

		Self.X:+ Sin(Self.Direction) * Self.Speed * TIME_mod
		Self.Y:- Cos(Self.Direction) * Self.Speed * TIME_mod
		Self.Draw()
		If Self.Y > GFX_Y - 40 And (Self.Direction>90 Or Self.Direction<-90)
			RemoveLink(self._link)
			For Local i=0 To 10
				TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(-90,90),Rand(200,250),Rnd(0,360),0,Rand(500,2000))
				TParticle.Create:TParticle(Fire,Self.X,Self.Y,Rand(-90,90),Rand(200,300),Rnd(0,360),0,Rand(500,2000))
			Next
		EndIf
		
		If ImagesCollide (FireballImage,Self.X,Self.Y,0,Player.Image,Player.X,Player.Y,0)
			Player.Glut:+ 2.0 * TIME_mod
			GAME_Risiko:+100* TIME_mod * RISKFACTOR
			
			TParticle.Create:TParticle(Fire2,Player.x,Player.y,Rnd(0,360),10,Rnd(0,360),0,Rand(1000,1500))
			TParticle.Create:TParticle(Fire2,Self.x,Self.y,Rnd(0,360),10,Rnd(0,360),0,Rand(1000,2500))
		EndIf
	End Method
	
	Method Draw()
		DrawImage FireballImage,Self.X,Self.Y
		TParticle.Create:TParticle(Fire,Self.x,Self.y,180+Rnd(-10,10),GAME_FLIGHTSPEED*10,Rnd(0,360),0,Rand(100,1500))
	End Method
	
End Type

Type TTextfield
	Field x:Float
	Field y:Float
	Field textsize:Float
	Field style:Byte '0 Rechts, 1 Mitte, 2 Links
	
	Field Content:TList
	
	Function Create:TTextfield(x:Int,y:Int,textsize:Float,style:Byte)
		Local T:TTextfield = New TTextfield
		T.x = X
		T.y = Y
		T.textsize = textsize
		T.style = style
		Return T
	End Function
	
	Method New()
		Self.Content:TList = New TList
	End Method
	
	Method AddContent(text:String)
		Self.Content.Addlast(text)
	End Method
	
	Method Draw()
		SetScale Self.textsize,Self.textsize
		Local i:Int = 0
		
		For Local t:String = EachIn Content
			Local py:Float = y + 12 * textsize * i
			Local px:Float
			Select Self.style
				Case 0 px = x
				Case 1 px = x - 0.5 * Len(t) * 8 * textsize
				Case 2 px = x - Len(t) * 8 * textsize
			End Select
				
				'Schatten
				SetColor 0,0,0
				SetAlpha 0.5
				DrawText t,px + Textsize*2,py + Textsize*2
				'Normal
				SetColor 255,255,255
				SetAlpha 0.9
				DrawText t,px,py
			i:+1
		Next
		SetScale 1,1
	End Method
End Type




Type TINPT_FIELD
	Global TINPT_FIELD_LIST:TList
	Field x				:Short
	Field y				:Short
	Field width			:Short
	Field height		:Short
	Field fieldname		:String
	Field inputtext		:String
	Field bordercolor	:Int
	Field bgcolor		:Int
	Field bgcolor2		:Int 'If Window activ
	Field textcolor		:Int
	Field alpha			:Float
	Field aktive		:Byte
	Field option		:Byte
	Field link			:TLink
	Field blink			:Byte
	Field blink_next	:Int
	Field blink_freq	:Int
	Rem
		1 = center Input Text
		2 = showwindowname
		4 = schreibschutz
	End Rem
	Field signallowed	:Byte
	Rem
		0 All ASCII allowed
		1 no letters
		2 no numbers
		4 no special
	End Rem
	
	Field cursorposition:Short
	
	Method New()
		If TINPT_FIELD_LIST=Null TINPT_FIELD_LIST = New TList
		bordercolor = $3A56C0
		bgcolor = $3250C8
		bgcolor2 = $0F1BFF
		textcolor = $D6BA00
		alpha = 0.5
		blink_freq = 300
	End Method
	
	Function create:TINPT_FIELD(x:Short,y:Short,width:Short,height:Short,name:String,signallowed:Byte=0)
		Local F:TINPT_FIELD = New TINPT_FIELD
		F.x = x
		F.y = y
		F.width = width
		F.height = height
		F.fieldname = name
		F.signallowed = signallowed
		F.link = TINPT_FIELD_LIST.Addlast(F)
		Return F:TINPT_FIELD
	End Function
	
		Method color(border:Int,bg1:Int,bg2:Int,text:Int,alpha:Float)
			self.bordercolor = border
			self.bgcolor = bg1
			self.bgcolor2 = bg2
			self.textcolor = text
			self.alpha = alpha
		End Method
		
		Method options(Defaulttext:String,aktive:Byte,option:Byte)
			self.inputtext = Defaulttext
			If aktive
				SetAktive()
			Else
				aktive = 0
			EndIf
			self.option = option
		End Method
		
		Method GetText:String()
			Return Self.inputtext
		End Method
			
		Method SetAktive()
			For Local F:TINPT_FIELD = EachIn TINPT_FIELD_LIST
				F.aktive = 0
			Next
			self.aktive = 1
			cursorposition = Len(inputtext)
		End Method
		
	Function UPDATE(Mx:Int,My:Int,Mhit:Byte)' Mx+My = Mauszeiger, Mhit = Mousehit(1)
		If TINPT_FIELD_LIST
			Local someoneaktiv = 0
			For Local F:TINPT_FIELD = EachIn TINPT_FIELD_LIST
				If F.process(Mx,My,Mhit) someoneaktiv=1
			Next
			SetColor 255 , 255 , 255
			SetAlpha 1
			Return someoneaktiv
		EndIf
	End Function
		
	Method process(Mx:Int,My:Int,Mhit:Byte)
		'DebugStop()
		If aktive
			Local a = GetChar()
			
			If a = 8 And cursorposition>0
				inputtext = Left(inputtext,cursorposition-1) + Right (inputtext,Len(inputtext)-cursorposition)
				cursorposition :-1
			ElseIf a = 13
				aktive = 0
			EndIf
			If KeyHit(KEY_DELETE) inputtext = Left(inputtext,cursorposition) + Right (inputtext,(Len(inputtext)-cursorposition)-1)
			If KeyHit(KEY_LEFT) And cursorposition>0 cursorposition :-1
			If KeyHit(KEY_RIGHT) And cursorposition<Len(inputtext) cursorposition :+1
			If KeyHit(KEY_END) cursorposition = Len(inputtext)
			If KeyHit(KEY_HOME) cursorposition = 0
			
			
			If (signallowed & 1) And ((a>64 And a<91) Or (a>96 And a<123)) a = 0'If no letters = true
			If (signallowed & 2) And (a>47 And a<58) a = 0'If no numbers = true
			If (signallowed & 4) And ((a<48) Or (a>57 And a<65) Or (a>90 And a<97) Or (a>122)) a = 0'If no special = true
			If a>30 And a<255
				inputtext = Left(inputtext,cursorposition) + Chr(a) + Right (inputtext,Len(inputtext)-cursorposition)

				'inputtext = inputtext + Chr(a)
				cursorposition :+1
			EndIf
		Else
			If  Mx>x And My>y And Mx<x+width And My<y+height And Mhit	self.SetAktive()
		EndIf
		
		
		If blink_next < Time_Now
			blink = 1 - blink
			blink_next = blink_freq + Time_Now
		EndIf
		
		self.Draw()
		Return aktive
	End Method
	
	Method Draw()
		Draw_SetColor(bordercolor)
		DrawRectHole( x , y , width , height)
	
		If Not aktive
			Draw_SetColor(bgcolor)
			SetAlpha alpha
		Else
			Draw_SetColor(bgcolor2)
			SetAlpha 0.5
		EndIf
		
		DrawRect x + 1 , y + 1 , width - 2 , height - 2
		
		SetAlpha 1
		
		If (option & 2)'Show Window name
			Draw_SetColor(textcolor)
			DrawMidText(x + width/2,y + 2,fieldname)
		EndIf
			Local xmod:Short
			xmod:Short = 2
			Local tmptext:String = inputtext
			Local breite = TextWidth(tmptext)
			If breite>(width-8)
				tmptext = Right(tmptext,(width-8)/(breite/Len(tmptext)))
				breite = TextWidth(tmptext)
			EndIf
			If (option & 1)'Center Text
				xmod:+ width/2 -breite/2
			EndIf
			DrawText tmptext,x+xmod-2,y+TextHeight(fieldname)+2
			
			Local cursorx = TextWidth(Left(tmptext , cursorposition) )
			
			If aktive And blink DrawRect x + xmod + cursorx , y + TextHeight(fieldname) + 2 , 2 , TextHeight(tmptext) - 4
			
	End Method
	
		Method Draw_SetColor(Color:Int)
			Local a=(Color & $FF000000)/$1000000
			Local r=(Color & $FF0000)/$10000
			Local g=(Color & $FF00)/$100
			Local b=Color & $FF
			SetColor r,g,b
		End Method
		
	Method GetInput:String()
		Return inputtext
	End Method
	
	Method Remove:TINPT_FIELD()
		RemoveLink(self.link)
		Return Null
	End Method
End Type

Type TScore
	Global TScore_List:TList
	Global MaxScores:Int = 10

	Field name:String
	Field points:Int
	Field newentry:Byte
	Field _link:TLink
	
	Function Init()
		If TScore_List = Null
			TScore_List = New TList
		Else
			ClearList TScore_List
		EndIf
		TScore.Load()
	End Function
	
	Function Add(Name:String,Points:Int, newentry:Byte = Null)
		Local t:TScore = New TScore
		Name = Trim(Name)
		Local clear:Int
		Repeat'Name:String von "=" Zeichen reinigen...
			clear = Instr(Name,"=")
			If clear Name = Left(Name,clear-1) + Mid(Name,clear+1)
		Until clear = 0
		
		t.Name = Name
		t.Points = Points
		t.newentry = newentry
		t._link = TScore_List.Addlast(t)
	End Function
	
	Function Save()
		Local Stream:TStream = WriteFile("Highscore.txt")
		For Local t:TScore = EachIn TScore_List
			WriteLine (Stream,t.Name+"="+t.points+"="+md5(t.Name+t.points))
		Next
		CloseFile Stream
	End Function
	
	Function Load()
		If FileType ("Highscore.txt") <> 1 Return 0
		Local Stream:TStream = ReadFile("Highscore.txt")
		While Eof(Stream)=0
			Local line:String = ReadLine(Stream)
			Local pos1:Int = Instr(line,"=")
			Local pos2:Int = Instr(line,"=",pos1+1)
			Local name:String = Left(line,pos1-1)
			Local points:Int = Int(Mid(line,pos1+1,pos2-pos1))
			If md5(name + points) = Mid(line,pos2+1)
				TScore.Add(name,points)
			EndIf
		Wend
		CloseFile Stream
	End Function
	
	Function Sort()
		SortList(TScore_List,1)
		Local i:Int = 0
		For Local t:TScore = EachIn TScore_List
			i:+1
			If i>TScore.MaxScores
				t.Remove()
			EndIf
		Next
		Return 1
	End Function
	
	Function GetLowest:Int() 
		TScore.Sort()
		If TScore_List = Null Or TScore_List.Count()=0
			Return 0
		ElseIf TScore_List.Count() < TScore.MaxScores
			Return 0
		Else
			Local _ts:TScore = TScore(TScore.TScore_List.Last())
			Return _ts.Points
		EndIf
	End Function
	
	Function FillTextfield(Textfield:TTextfield)
		Textfield.AddContent("___ Highscore Version "+Version+" ___")
		Textfield.AddContent("Name   - - - Points")
		Local _number:Int
		For Local t:TScore = EachIn TScore_List
			_number:+1
			Textfield.AddContent("")
			If Not t.newentry
				Textfield.AddContent(_number+". "+t.Name + " - - - " + t.Points)
			Else
				Textfield.AddContent("New >>> "+_number+". "+t.Name + " - - - " + t.Points+" <<< New")
			EndIf
		Next
	End Function
	
	Method compare(other:Object)
		Local t:TScore = TScore (other)
			If t = Self Return 0
			If t.points > self.points
				Return 1
			ElseIf t.points < self.points
				Return -1
			EndIf
			Return 0
	End Method
	
	Method Remove()
		RemoveLink(self._link)
	End Method
End Type


Global Background:TBackground = New TBackground
Background.Init("BG1.png",0,10)
TStar.Init()
Local logo:TImage = LoadImage("Logo.png")
MidHandleImage logo

HideMouse

Global Textfield:TTextfield = TTextfield.Create(GFX_X/2,GFX_Y/1.5,1,1)
Textfield.AddContent("by Illusion-Games")
Textfield.AddContent("5.4.2006")
Textfield.AddContent("")
Textfield.AddContent(" Version "+Version)
Textfield.AddContent("Press SPACE or ESC to continue")
Global Textfield2:TTextfield = TTextfield.Create(10,10,1,0)
Textfield2.AddContent("Arrowkeys = Move Ship")
Textfield2.AddContent("Dons touch the asteroids!")
Textfield2.AddContent("Dons fly into the sun!")

Time_LastUpdate = MilliSecs()

Repeat
	Cls
	TIME_Update()
	Background.Draw()
	TStar.Update()
	DrawImage logo,GFX_X/2,GFX_Y/2
	Textfield.Draw()
	Textfield2.Draw()
	Flip
Until KeyHit(KEY_ESCAPE) Or KeyHit(KEY_SPACE) Or KeyHit(KEY_ENTER)

Textfield = Null
Textfield2 = Null





Global Player:TRocket = New TRocket


Global RandR:TImage = LoadImage("RRand.PNG")
Global RandL:TImage = LoadImage("LRand.PNG")
Global RandY:Float = 0
Global Randtiles:Int = Ceil(GFX_Y/86.0)-1

Global Sunlight:TImage = LoadImage("Sunlight.png")
Global Firetiles:Int = Ceil(GFX_X/100.0)-1

If TParticle.TParticle_List = Null TParticle.TParticle_List = New TList
Global Fire:TParticle_Info = TParticle_Info.Create:TParticle_Info("Firepartikel1.png",255,255,200,1,255,50,0,0)
Global Fire2:TParticle_Info = TParticle_Info.Create:TParticle_Info("Firepartikel2.png",200,200,255,1,255,50,0,0)
Global RocketExplode:TParticle_Info = TParticle_Info.Create:TParticle_Info("Firepartikel1.png",50,255,255,1,0,0,255,0)
Global Funken:TParticle_Info = TParticle_Info.Create:TParticle_Info("Funken1.png",255,255,255,1,0,100,255,0)
TAsteroid.Init()
TFireball.Init()

Repeat
GAME_Init()

FlushKeys()
Repeat
Cls
	GAME_Progress()

	TIME_Update()
			
	If Player.Dead = 0 GAME_TIME:+Time_MS
	
	Background.Draw()
	TStar.Update()

	
	Player.Steering() 
	Player.Draw()
	TAsteroid.Update()
	TParticle.Update()
	TFireball.Update()
	
	Local xtiles:Int = Ceil(GFX_X/100.0)-1
	SetBlend LIGHTBLEND
	For Local i=0 To Firetiles
		DrawImage Sunlight,i*100,GFX_Y-100
	Next
	SetBlend Alphablend
	
	RandY = (RandY + GAME_FLIGHTSPEED * TIME_mod * 10) Mod 86
	For Local i= -1 To Randtiles
		DrawImage RandL,0,i * 86 + RandY
		DrawImage RandR,GFX_X-48,i * 86 + RandY
	Next
	
	SetAlpha 0.5
	SetColor 0 , 0 , 0
	DrawRect 5,5,130,45
	SetColor 50,80,200
	DrawRect 5,50,130,15
	
	
	SetAlpha 0.8
	SetColor 0,0,0
	DrawText "Time: "+Int(Ceil(GAME_TIME/1000.0)),12,12
	DrawText "Asteroids: "+GAME_ASTEROIDS,12,22
	DrawText "Risiko: "+Int(GAME_RISIKO),12,32
	DrawText "Points: "+Points(),12,52
	SetAlpha 1
	SetColor 100,200,255
	DrawText "Time: "+Int(Ceil(GAME_TIME/1000.0)),10,10
	DrawText "Asteroids: "+GAME_ASTEROIDS,10,20
	DrawText "Risiko: "+Int(GAME_RISIKO),10,30
	DrawText "Points: "+Points(),10,50
	
	
	If Player.Dead
		Local i:Float = Player.Dead / 5000.0
		SetAlpha i
		SetColor 0,0,0
		SetBlend ALPHABLEND
		DrawRect 0,0,GFX_X,GFX_Y
		SetAlpha 1
		SetColor 255,255,255
		SetBlend Alphablend
		If i>1 GAME_OVER = 1
	EndIf
	
	SetColor 255,255,255
	SetScale 0.5,0.5
	DrawImage logo,GFX_X - 150,50
	SetScale 1 , 1
	If KeyHit(KEY_D) DEBUG = 1 - DEBUG
	If KeyHit(KEY_ESCAPE) GAME_OVER = 1
Flip
Until GAME_OVER
FlushKeys()

TScore.Init()
If Points() > TScore.GetLowest:Int()
	Local _name:TINPT_FIELD = TINPT_FIELD.create(GFX_X/2-100 , GFX_Y/2-20 , 200 , 40 , "[please enter name]")
	_name.options(GAME_PLAYERID,1,3)
	Repeat
		Cls
		TIME_Update()
		Background.Draw()
		TStar.Update()
		SetAlpha 1
		SetColor 255,255,255
		SetScale 0.5,0.5
		DrawImage logo,GFX_X - 150,50
		SetScale 1,1
		TINPT_FIELD.Update(MouseX(),MouseY(),MouseHit(1))
		Flip
	Until KeyHit(KEY_ENTER)
	GAME_PLAYERID = _name.GetText()
	_name.Remove()
	_name = Null
	Options_Save()
	
	TScore.Add(GAME_PLAYERID , Points() , True)
EndIf
TScore.Sort()
TScore.Save()

Textfield:TTextfield = TTextfield.Create(GFX_X/2,GFX_Y/3,1,1)
Textfield.AddContent("Game Over")
Textfield.AddContent("")
Textfield.AddContent("")
Textfield.AddContent("Time: "+Int(Ceil(GAME_TIME/1000.0)))
Textfield.AddContent("")
Textfield.AddContent("Asteroids: "+GAME_ASTEROIDS)
Textfield.AddContent("")
Textfield.AddContent("Risiko: "+Int(GAME_RISIKO))
Textfield.AddContent("")
Textfield.AddContent("Points: "+ Points())
Textfield.AddContent("")
Textfield.AddContent("")
TScore.FillTextfield(Textfield)
Textfield2:TTextfield = TTextfield.Create(10,10,1,0)
Textfield2.AddContent("programmed by Christian Geissler")
Textfield2.AddContent("alias Firstdeathmaker")
Textfield2.AddContent("visit www.blitzforum.de")
Textfield2.AddContent("programmed in BMax")

GAME_EXIT:Byte = 0

If GAME_OVER
	Repeat
		Cls
		TIME_Update()
		
		Background.Draw()
		TStar.Update()
		SetColor 255,255,255
		SetAlpha 1
		SetScale 2,2
		Textfield.Draw()
		Textfield2.Draw()
		
		If KeyDown(KEY_DOWN) Textfield.Y:+100.0*TIME_Mod
		If KeyDown(KEY_UP) Textfield.Y:-100.0*TIME_Mod
		
		SetColor 255,255,255
		SetScale 0.5,0.5
		DrawImage logo,GFX_X - 150,50
		SetScale 1,1
		DrawMidText(GFX_X/2,GFX_Y-20,"Press SPACE to try again, Press ESC or ENTER to leave")

		Flip
		
		If KeyHit(KEY_ESCAPE) Or KeyHit(KEY_ENTER) GAME_EXIT = 1
	Until GAME_EXIT Or KeyHit(KEY_SPACE)
EndIf

Until GAME_EXIT

End


'Hilfsfunktionen
Function DrawMidText(X,Y,Text$)
	Local width = Len (Text) * 8
	DrawText Text,X-width/2,Y
End Function

Function ReturnLine:String(Stream:TStream,Paramitter:String)'Liefert einen bestimmten Eintrag aus einer Inidatei mit bez=worth
	SeekStream Stream,0
	Repeat
		Local bez:String = ReadLine(Stream)
		Local worth:String = Mid(bez,Instr(bez,"=")+1)
		bez = Left(bez,Instr(bez,"=")-1)
		If bez = Paramitter Return worth
	Until Eof(Stream)
	Return 0
End Function

Function DrawRectHole(_x:Int,_y:Int,_w:Int,_h:Int)
	DrawLine _x , _y , _x + _w , _y
	DrawLine _x , _y , _x , _y + _h
	DrawLine _x + _w , _y , _x + _w , _y + _h
	DrawLine _x , _y + _h , _x + _w , _y + _h
End Function